import { Injector, NgModule } from '@angular/core';
import { XHRBackend } from '@angular/http';
import { AngularApiHandlerConfig } from './angular-api-handler.config';
import { AngularApiHandlerService, AngularApiHandlerBackendService } from './angular-api-handler.service';
export function angularApiHandlerBackendServiceFactory(injector, service, config) {
    var backend = new AngularApiHandlerBackendService(injector, service, config);
    return backend;
}
export var AngularApiHandlerModule = (function () {
    function AngularApiHandlerModule() {
    }
    /**
     *  Configure Module
     *
     * @returns {{ngModule: AngularApiHandlerModule, providers: Array}}
     */
    AngularApiHandlerModule.forRoot = function (service, config) {
        return {
            ngModule: AngularApiHandlerModule,
            providers: [
                { provide: AngularApiHandlerService, useClass: service },
                { provide: AngularApiHandlerConfig, useValue: config }
            ]
        };
    };
    AngularApiHandlerModule.decorators = [
        { type: NgModule, args: [{
                    providers: [{ provide: XHRBackend,
                            useFactory: angularApiHandlerBackendServiceFactory,
                            deps: [Injector, AngularApiHandlerService, AngularApiHandlerConfig] }]
                },] },
    ];
    /** @nocollapse */
    AngularApiHandlerModule.ctorParameters = [];
    return AngularApiHandlerModule;
}());
//# sourceMappingURL=angular-api-handler.module.js.map